;************************************
; written by: *
; date: *
; version: *
; file saved as: *
; for PIC *
; clock frequency: *
;************************************
; PROGRAM FUNCTION: _______________________________________
;______________________________________________________________
 list P = PIC16F84A
 include "c:\Program Files (x86)\Microchip\MPASM Suite\P16F84A.INC"
 __config _HS_OSC & _WDT_OFF & _CP_OFF
;============
; Declarations:
porta equ 05
portb equ 06
CounterA equ 0C
CounterB equ 0D
CounterC equ 0E
Jed equ 0F
Des equ 10
Sto equ 11
Hilj equ 12
Temp_w equ 13 
Temp_st equ 14
Temp_port equ 15 
setovan equ 16  

 org 0
	 goto Start
 org 4
 goto Inter

;=============
; Povecaj: Rutina za uvecavanje cifara
Inter
 movwf Temp_w		;Sacuvaj vrednost akumulatora.
 movfw STATUS		;Sacuvaj vrednost 
 movwf Temp_st		;status registra.
 incf Jed, f		;Povecaj cifru jedinica za jedan
 movlw D'10'		;Proveri da li je vrednost
 subwf Jed,w		;jedinica veca od 10?
 btfss STATUS, Z	;Ako nije
 goto Intkraj		;idi na kraj, 
 clrf Jed			;a ako jeste cifra jedinica=0 a
 incf Des,f			;cifra desetica se povecava za 1
 movlw D'10'		;Proveri da li je cifra desetica 
 subwf Des,w		;veca od 10?
 btfss STATUS, Z	;Ako nije
 goto Intkraj		;idi na kraj,
 clrf Des			;a ako jeste cifru desetica postavi na 0 i
 incf Sto,f			;povecaj cifru stotina
 movlw D'10'
 subwf Sto,w
 btfss STATUS, Z
 goto Intkraj
 clrf Sto
 incf Hilj,f
 movlw D'10'
 subwf Hilj,w
 btfss STATUS, Z
 goto Intkraj
 clrf Hilj
Intkraj 
; banksel portb
; bcf portb,0
 call Prikazi		;prikazi cifre na displayu
 btfsc porta,4		;Proveri da li je jos uvek fotocelija zatvorena?
 goto Intkraj		;Ako jeste ponavljaj dok se ne oslobodi,
 movfw Temp_st 		;a ako nije vrati vrednost 
 movwf STATUS		;status registra i
 movfw Temp_w		;akumulatora
 return
;================
; Subroutines:
Init 
 clrf porta			; resets input/output ports
 clrf portb			;
 clrf Jed			;postavi sve cifre na 0
 clrf Des			;
 clrf Sto			;
 clrf Hilj			;
 movlw B'00010000'	;Postavi pinove od A0-A3 kao output a A4 kao input za fotoceliju
 banksel TRISA		;bsf STATUS,5 ; select bank 1
 movwf TRISA 		;
 movlw B'00000000' 	;portB kao output (za led display)
 movwf TRISB		
 ; bcf STATUS,5 ; select bank 1
 ;banksel OPTION_REG
 ;movlw B'00100000' ; omoguciti RB0 kroz option registar
 ;option
 ;movwf OPTION_REG
 ;banksel OPTION_REG
 ;movlw B'10010000'
 ;bcf OPTION_REG, INTEDG   ; interrupt on positive
 ;banksel INTCON
 ;bcf INTCON, INTF    ; clear interrupt flag
 ;bcf INTCON, INTE    ; mask for external interrupts
 ;bcf INTCON, GIE     ; enable interrupts
 banksel portb
 return
;=============
; timing
;PIC Time Delay = 0,00500700 s with Osc = 4000000 Hz
Time
		movlw	D'7'
		movwf	CounterB
		movlw	D'126'
		movwf	CounterA
loop		decfsz	CounterA,1
		goto	loop
		decfsz	CounterB,1
		goto	loop
		return

;=============
; Display:
Display
 addwf PCL, f		;povecaj vrednost program contera za cifru
 retlw b'00000100' ; code for 0
 retlw b'01110110' ; code for 1
 retlw b'00100001' ; code for 2
 retlw b'01100000' ; code for 3
 retlw b'01010010' ; code for 4
 retlw b'01001000' ; code for 5
 retlw b'00001000' ; code for 6
 retlw b'01100110' ; code for 7
 retlw b'00000000' ; code for 8
 retlw b'01000000' ; code for 9

;=============
; Prikazi:

Prikazi
 banksel porta
 clrf porta      ;postavi portA na nulu
 movfw Jed       ; posalji vrednost jedinica u akumulator
 call Display    ; odredi pattern displeja
 movwf portb     ; posalji na port
 movlw B'1110'   ; odaberi displej JEDINICA za prikazivanje
 movwf porta     ; posalji na portA
 call Time 
 clrf porta      ;postavi portA na nulu
 movfw Des       ; posalji vrednost desetica u akumulator
 call Display    ; odredi pattern displeja
 movwf portb     ; posalji na port
 movlw B'1101'   ; odaberi displej DESETICA za prikazivanje
 movwf porta     ; posalji na portA 
 call Time 
 clrf porta      ;postavi portA na nulu
 movfw Sto       ; posalji vrednost jedinica u akumulator
 call Display    ; odredi pattern displeja
 movwf portb     ; posalji na port
 movlw B'1011'   ; odaberi displej STOTINA za prikazivanje
 movwf porta     ; posalji na portA 
 call Time 
 clrf porta      ;postavi portA na nulu
 movfw Hilj       ; posalji vrednost jedinica u akumulator
 call Display    ; odredi pattern displeja
 movwf portb     ; posalji na port
 movlw B'0111'   ; odaberi displej HILJADA za prikazivanje
 movwf porta     ; posalji na portA 
 call Time 
 return


;=============
; Reset:
Nuluj
 clrf Jed
 clrf Des
 clrf Sto
 clrf Hilj
 return 

Reseting
 movwf Temp_w		;Sacuvaj akumulator.
 movfw portb		;Sacuvaj vrednost portaB
 movwf Temp_port	;u promenljvoj Temp_port
 banksel TRISB		;Postavi pin RB4 na input
 movlw B'00010000'	;da bi proverio stanje pritisnutog
 movwf TRISB		;dugmeta za reset kauntera.
 bcf OPTION_REG,7	;Omoguci pull-up otpornike
 banksel portb		;
 bcf portb, 4		;-Ovo je mozda nepotrebno
 btfss portb, 4		;Proveri stanje RB4 pina (da li je dugme pritisnuto)
 call Nuluj			;Ako je pritisnuto postavi sve vrednosti na 0
 banksel TRISB		;Vrati portB na output
 movlw B'00000000'	;
 movwf TRISB		;
 bsf OPTION_REG,7	;Iskljuci pull-up
 banksel portb		;
 movfw Temp_port	;Vrati vrednost portaB
 movwf portb
 return
 

;=============
; Program Start:
Start
 call Init
Main
 ;btfss porta,2
 ;call Time
 banksel porta
 btfsc porta,4	;proveri da li je fotocelija zatvorena
 call Inter		;ako jeste povecaj vrednost
 call Prikazi	;Prikazi cifre na displayu
 call Reseting	;Resetuj cifre na 0
 goto Main		;
 END